# Copyright 2007 Annette Huck.
# This file is part of Steckdosen.
# Steckdosen is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
# Steckdosen is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with Foobar. If not, see http://www.gnu.org/licenses/>.

#this import statement allows access to the karamba functions
import karamba
import string
import time

########### globale Variablen ###################

kugelZustand=-1
kugelImgAus=0
kugelImgAn=0
kugelProcID=0
salzZustand=-1
salzImgAus=0
salzImgAn=0
salzProcID=0
klavierZustand=-1
klavierImgAus=0
klavierImgAn=0
klavierProcID=0
verstaerkerZustand=-1
verstaerkerImgAus=0
verstaerkerImgAn=0
verstaerkerProcID=0

sleepTime=3

########### bei Umbelegung/Umkonfiguration der Steckdosen zu ndern ###################

### String des Steckplatzes ###
kugelUsbSteckplatz="1"
salzUsbSteckplatz="4"
klavierUsbSteckplatz="2"
verstaerkerUsbSteckplatz="3"

### Pfade der Bilddateien ###
kugelAnBildPfad="glaskugel-on.png"
kugelAusBildPfad="glaskugel-off.png"
salzAnBildPfad="salz-on.png"
salzAusBildPfad="salz-off.png"
klavierAnBildPfad="klavier-on.png"
klavierAusBildPfad="klavier-off.png"
verstaerkerAnBildPfad="glaskugel-on.png"
verstaerkerAusBildPfad="glaskugel-off.png"
updateJetztPfad="update-jetzt.png"

########### Position der Bilder im Widget ###################
########### (ggf. auch in steckdosen.theme zu ndern) ###################

kugelPosX=20
kugelPosY=15
salzPosX=130
salzPosY=15
klavierPosX=20
klavierPosY=125
verstaerkerPosX=130
verstaerkerPosY=125
updateJetztPosX=30
updateJetztPosY=270

########### KUGEL-Objekt ###################

def setRealKugelZustand(widget):
    global kugelZustand
    global kugelProcID
    global kugelUsbSteckplatz
    myCommand = ["sudo", "sispmctl", "-n", "-q", "-g", kugelUsbSteckplatz]
    kugelProcID=karamba.executeInteractive(widget, myCommand)

def changeKugelZustand():
    global kugelZustand
    if kugelZustand == 0:
        kugelZustand=1
    elif kugelZustand == 1:
        kugelZustand=0

def schalteKugel(widget):
    global kugelZustand
    global kugelImgAus
    global kugelImgAn
    global kugelUsbSteckplatz
    global kugelAnBildPfad
    global kugelAusBildPfad
    global kugelPosX
    global kugelPosY
    if kugelZustand == 0:
        myCommand = ["sudo", "sispmctl", "-o", kugelUsbSteckplatz]
        karamba.executeInteractive(widget, myCommand)
        if kugelImgAus != 0:
            karamba.deleteImage(widget, kugelImgAus)
            kugelImgAus = 0
        kugelImgAn = karamba.createImage(widget, kugelPosX, kugelPosY, kugelAnBildPfad)
        karamba.attachClickArea(widget, kugelImgAn)
    elif kugelZustand == 1:
        myCommand = ["sudo", "sispmctl", "-f", kugelUsbSteckplatz]
        karamba.executeInteractive(widget, myCommand)
        if kugelImgAn != 0:
            karamba.deleteImage(widget, kugelImgAn)
            kugelImgAn = 0
        kugelImgAus = karamba.createImage(widget, kugelPosX, kugelPosY, kugelAusBildPfad)
        karamba.attachClickArea(widget, kugelImgAus)
    changeKugelZustand()

########### SALZ-Objekt ###################

def setRealSalzZustand(widget):
    global salzZustand
    global salzProcID
    global salzUsbSteckplatz
    myCommand = ["sudo", "sispmctl", "-n", "-q", "-g", salzUsbSteckplatz]
    salzProcID=karamba.executeInteractive(widget, myCommand)

def changeSalzZustand():
    global salzZustand
    if salzZustand == 0:
        salzZustand=1
    elif salzZustand == 1:
        salzZustand=0

def schalteSalz(widget):
    global salzZustand
    global salzImgAus
    global salzImgAn
    global salzUsbSteckplatz
    global salzAnBildPfad
    global salzAusBildPfad
    global salzPosX
    global salzPosY
    if salzZustand == 0:
        myCommand = ["sudo", "sispmctl", "-o", salzUsbSteckplatz]
        karamba.executeInteractive(widget, myCommand)
        if salzImgAus != 0:
            karamba.deleteImage(widget, salzImgAus)
            salzImgAus = 0
        salzImgAn = karamba.createImage(widget, salzPosX, salzPosY, salzAnBildPfad)
        karamba.attachClickArea(widget, salzImgAn)
    elif salzZustand == 1:
        myCommand = ["sudo", "sispmctl", "-f", salzUsbSteckplatz]
        karamba.executeInteractive(widget, myCommand)
        if salzImgAn != 0:
            karamba.deleteImage(widget, salzImgAn)
            salzImgAn = 0
        salzImgAus = karamba.createImage(widget, salzPosX, salzPosY, salzAusBildPfad)
        karamba.attachClickArea(widget, salzImgAus)
    changeSalzZustand()

########### KLAVIER-Objekt ###################

def setRealKlavierZustand(widget):
    global klavierZustand
    global klavierProcID
    global klavierUsbSteckplatz
    myCommand = ["sudo", "sispmctl", "-n", "-q", "-g", klavierUsbSteckplatz]
    klavierProcID=karamba.executeInteractive(widget, myCommand)

def changeKlavierZustand():
    global klavierZustand
    if klavierZustand == 0:
        klavierZustand=1
    elif klavierZustand == 1:
        klavierZustand=0

def schalteKlavier(widget):
    global klavierZustand
    global klavierImgAus
    global klavierImgAn
    global klavierUsbSteckplatz
    global klavierAnBildPfad
    global klavierAusBildPfad
    global klavierPosX
    global klavierPosY
    if klavierZustand == 0:
        myCommand = ["sudo", "sispmctl", "-o", klavierUsbSteckplatz]
        karamba.executeInteractive(widget, myCommand)
        if klavierImgAus != 0:
            karamba.deleteImage(widget, klavierImgAus)
            klavierImgAus = 0
        klavierImgAn = karamba.createImage(widget, klavierPosX, klavierPosY, klavierAnBildPfad)
        karamba.attachClickArea(widget, klavierImgAn)
    elif klavierZustand == 1:
        myCommand = ["sudo", "sispmctl", "-f", klavierUsbSteckplatz]
        karamba.executeInteractive(widget, myCommand)
        if klavierImgAn != 0:
            karamba.deleteImage(widget, klavierImgAn)
            klavierImgAn = 0
        klavierImgAus = karamba.createImage(widget, klavierPosX, klavierPosY, klavierAusBildPfad)
        karamba.attachClickArea(widget, klavierImgAus)
    changeKlavierZustand()

########### VERSTRKER-Objekt ###################

def setRealVerstaerkerZustand(widget):
    global verstaerkerZustand
    global verstaerkerProcID
    global verstaerkerUsbSteckplatz
    myCommand = ["sudo", "sispmctl", "-n", "-q", "-g", verstaerkerUsbSteckplatz]
    verstaerkerProcID=karamba.executeInteractive(widget, myCommand)

def changeVerstaerkerZustand():
    global verstaerkerZustand
    if verstaerkerZustand == 0:
        verstaerkerZustand=1
    elif verstaerkerZustand == 1:
        verstaerkerZustand=0

def schalteVerstaerker(widget):
    global verstaerkerZustand
    global verstaerkerImgAus
    global verstaerkerImgAn
    global verstaerkerUsbSteckplatz
    global verstaerkerAnBildPfad
    global verstaerkerAusBildPfad
    global verstaerkerPosX
    global verstaerkerPosY
    if verstaerkerZustand == 0:
        myCommand = ["sudo", "sispmctl", "-o", verstaerkerUsbSteckplatz]
        karamba.executeInteractive(widget, myCommand)
        if verstaerkerImgAus != 0:
            karamba.deleteImage(widget, verstaerkerImgAus)
            verstaerkerImgAus = 0
        verstaerkerImgAn = karamba.createImage(widget, verstaerkerPosX, verstaerkerPosY, verstaerkerAnBildPfad)
        karamba.attachClickArea(widget, verstaerkerImgAn)
    elif verstaerkerZustand == 1:
        myCommand = ["sudo", "sispmctl", "-f", verstaerkerUsbSteckplatz]
        karamba.executeInteractive(widget, myCommand)
        if verstaerkerImgAn != 0:
            karamba.deleteImage(widget, verstaerkerImgAn)
            verstaerkerImgAn = 0
        verstaerkerImgAus = karamba.createImage(widget, verstaerkerPosX, verstaerkerPosY, verstaerkerAusBildPfad)
        karamba.attachClickArea(widget, verstaerkerImgAus)
    changeVerstaerkerZustand()

############ Update der Zustnde ###################

def updateSteckdosen(widget):
    global sleepTime
    updateJetztImg = karamba.createImage(widget, updateJetztPosX, updateJetztPosY, updateJetztPfad)
    karamba.redrawWidget(widget)
    setRealKugelZustand(widget)
    time.sleep(sleepTime)
    setRealSalzZustand(widget)
    time.sleep(sleepTime)
    setRealKlavierZustand(widget)
    time.sleep(sleepTime)
    setRealVerstaerkerZustand(widget)
    time.sleep(sleepTime)
    karamba.deleteImage(widget, updateJetztImg)
    karamba.redrawWidget(widget)

############ INIT ###################

#this is called when your widget is initialized
def initWidget(widget):
    kugelImg = karamba.getThemeImage(widget, "Kugel")
    karamba.attachClickArea(widget, kugelImg)
    salzImg = karamba.getThemeImage(widget, "Salz")
    karamba.attachClickArea(widget, salzImg)
    klavierImg = karamba.getThemeImage(widget, "Klavier")
    karamba.attachClickArea(widget, klavierImg)
    verstaerkerImg = karamba.getThemeImage(widget, "Verstaerker")
    karamba.attachClickArea(widget, verstaerkerImg)
    updateImg = karamba.getThemeImage(widget, "Update")
    karamba.attachClickArea(widget, updateImg)
    time.sleep(sleepTime)
    setRealKugelZustand(widget)
    time.sleep(sleepTime)
    setRealSalzZustand(widget)
    time.sleep(sleepTime)
    setRealKlavierZustand(widget)
    time.sleep(sleepTime)
    setRealVerstaerkerZustand(widget)
    time.sleep(sleepTime)
    myText = karamba.getThemeText(widget, "MessageEins")
    karamba.deleteText(widget,myText)
    myText = karamba.getThemeText(widget, "MessageZwei")
    karamba.deleteText(widget,myText)


#This is called when your widget is closed.  You can use this to clean
#up open files, etc.  You don't need to delete text and images in your
#theme.  That is done automatically.  This callback is just for cleaning up
#external things.  Most people don't need to put anything here.
def widgetClosed(widget):
    pass

#this is called everytime your widget is updated
#the update inverval is specified in the .theme file
def widgetUpdated(widget):
    pass

#This gets called everytime our widget is clicked.
#Notes:
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button clicked:
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
#                    4,5 = Scroll wheel up and down
def widgetClicked(widget, x, y, button):
    pass

#This gets called everytime our widget is clicked.
#Notes
#  widget = reference to our widget
#  x = x position (relative to our widget)
#  y = y position (relative to our widget)
#  botton = button being held:
#                    0 = No Mouse Button
#                    1 = Left Mouse Button
#                    2 = Middle Mouse Button
#                    3 = Right Mouse Button, but this will never happen
#                        because the right mouse button brings up the
#                        Karamba menu.
def widgetMouseMoved(widget, x, y, button):
    #Warning:  Don't do anything too intensive here
    #You don't want to run some complex piece of code everytime the mouse moves
    #myText = karamba.getThemeText(widget, "untenText")
    #karamba.changeText(widget, myText, "Bewegt")
    #myText = karamba.getThemeText(widget, "mouseText")
    #karamba.changeText(widget, myText, "Haaa! Maus bewegt")
    pass


#This gets called when an item is clicked in a popup menu you have created.
#  menu = a reference to the menu
#  id = the number of the item that was clicked.
def menuItemClicked(widget, menu, id):
    pass

#This gets called when an item is clicked in the theme CONFIGURATION menu,
#not the popup menus that you create.
#  key = the reference to the configuration key that was changed
#  value = the new value (true or false) that was selected
def menuOptionChanged(widget, key, value):
    pass

#This gets called when a meter (image, text, etc) is clicked.
# NOTE you must use attachClickArea() to make a meter
# clickable.  
#  widget = reference to your theme
#  meter = the meter clicked
#  button = the button clicked (see widgetClicked for button numbers)
def meterClicked(widget, meter, button):
    if meter == karamba.getThemeImage(widget, "Kugel"):
        schalteKugel(widget)
    if meter == karamba.getThemeImage(widget, "Salz"):
        schalteSalz(widget)
    if meter == karamba.getThemeImage(widget, "Klavier"):
        schalteKlavier(widget)
    if meter == karamba.getThemeImage(widget, "Verstaerker"):
        schalteVerstaerker(widget)
    if meter == karamba.getThemeImage(widget, "Update"):
        updateSteckdosen(widget)

#This gets called when a command you have executed with executeInteractive() outputs something
#to stdout.  This way you can get the output of for example kdialog without freezing up the widget
#waiting for kdialog to end.
#  widget = reference to your theme
#  pid = process number of the program outputting (use this if you execute more than out process)
#  output = the text the program outputted to stdout
def commandOutput(widget, pid, output):
    global kugelProcID
    global salzProcID
    global klavierProcID
    global verstaerkerProcID
    if kugelProcID == pid:
        global kugelZustand
        global kugelImgAus
        global kugelImgAn
        global kugelAnBildPfad
        global kugelAusBildPfad
        global kugelPosX
        global kugelPosY
        if string.atoi(output) == 1:
            kugelZustand = 1
        elif string.atoi(output) == 0:
            kugelZustand = 0
        else:
            print 'Fehler im Objekt Kugel'
        if kugelZustand == 0:
            if kugelImgAus != 0:
                karamba.deleteImage(widget, kugelImgAus)
                kugelImgAus = 0
            if kugelImgAn != 0:
                karamba.deleteImage(widget, kugelImgAn)
                kugelImgAn = 0
            kugelImgAus = karamba.createImage(widget, kugelPosX, kugelPosY, kugelAusBildPfad)
            karamba.attachClickArea(widget, kugelImgAus)
        elif kugelZustand == 1:
            if kugelImgAus != 0:
                karamba.deleteImage(widget, kugelImgAus)
                kugelImgAus = 0
            if kugelImgAn != 0:
                karamba.deleteImage(widget, kugelImgAn)
                kugelImgAn = 0
            kugelImgAn = karamba.createImage(widget, kugelPosX, kugelPosY, kugelAnBildPfad)
            karamba.attachClickArea(widget, kugelImgAn)
    if salzProcID == pid:
        global salzZustand
        global salzImgAus
        global salzImgAn
        global salzAnBildPfad
        global salzAusBildPfad
        global salzPosX
        global salzPosY
        if string.atoi(output) == 1:
            salzZustand = 1
        elif string.atoi(output) == 0:
            salzZustand = 0
        else:
            print 'Fehler im Objekt Salz'
        if salzZustand == 0:
            if salzImgAus != 0:
                karamba.deleteImage(widget, salzImgAus)
                salzImgAus = 0
            if salzImgAn != 0:
                karamba.deleteImage(widget, salzImgAn)
                salzImgAn = 0
            salzImgAus = karamba.createImage(widget, salzPosX, salzPosY, salzAusBildPfad)
            karamba.attachClickArea(widget, salzImgAus)
        elif salzZustand == 1:
            if salzImgAus != 0:
                karamba.deleteImage(widget, salzImgAus)
                salzImgAus = 0
            if salzImgAn != 0:
                karamba.deleteImage(widget, salzImgAn)
                salzImgAn = 0
            salzImgAn = karamba.createImage(widget, salzPosX, salzPosY, salzAnBildPfad)
            karamba.attachClickArea(widget, salzImgAn)
    if klavierProcID == pid:
        global klavierZustand
        global klavierImgAus
        global klavierImgAn
        global klavierAnBildPfad
        global klavierAusBildPfad
        global klavierPosX
        global klavierPosY
        if string.atoi(output) == 1:
            klavierZustand = 1
        elif string.atoi(output) == 0:
            klavierZustand = 0
        else:
            print 'Fehler im Objekt Klavier'
        if klavierZustand == 0:
            if klavierImgAus != 0:
                karamba.deleteImage(widget, klavierImgAus)
                klavierImgAus = 0
            if klavierImgAn != 0:
                karamba.deleteImage(widget, klavierImgAn)
                klavierImgAn = 0
            klavierImgAus = karamba.createImage(widget, klavierPosX, klavierPosY, klavierAusBildPfad)
            karamba.attachClickArea(widget, klavierImgAus)
        elif klavierZustand == 1:
            if klavierImgAus != 0:
                karamba.deleteImage(widget, klavierImgAus)
                klavierImgAus = 0
            if klavierImgAn != 0:
                karamba.deleteImage(widget, klavierImgAn)
                klavierImgAn = 0
            klavierImgAn = karamba.createImage(widget, klavierPosX, klavierPosY, klavierAnBildPfad)
            karamba.attachClickArea(widget, klavierImgAn)
    if verstaerkerProcID == pid:
        global verstaerkerZustand
        global verstaerkerImgAus
        global verstaerkerImgAn
        global verstaerkerAnBildPfad
        global verstaerkerAusBildPfad
        global verstaerkerPosX
        global verstaerkerPosY
        if string.atoi(output) == 1:
            verstaerkerZustand = 1
        elif string.atoi(output) == 0:
            verstaerkerZustand = 0
        else:
            print 'Fehler im Objekt Verstrker'
        if verstaerkerZustand == 0:
            if verstaerkerImgAus != 0:
                karamba.deleteImage(widget, verstaerkerImgAus)
                verstaerkerImgAus = 0
            if verstaerkerImgAn != 0:
                karamba.deleteImage(widget, verstaerkerImgAn)
                verstaerkerImgAn = 0
            verstaerkerImgAus = karamba.createImage(widget, verstaerkerPosX, verstaerkerPosY, verstaerkerAusBildPfad)
            karamba.attachClickArea(widget, verstaerkerImgAus)
        elif verstaerkerZustand == 1:
            if verstaerkerImgAus != 0:
                karamba.deleteImage(widget, verstaerkerImgAus)
                verstaerkerImgAus = 0
            if verstaerkerImgAn != 0:
                karamba.deleteImage(widget, verstaerkerImgAn)
                verstaerkerImgAn = 0
            verstaerkerImgAn = karamba.createImage(widget, verstaerkerPosX, verstaerkerPosY, verstaerkerAnBildPfad)
            karamba.attachClickArea(widget, verstaerkerImgAn)

#This gets called when another theme sends a message.
#  widget = reference to your theme
#  caller = "pretty" name or regular name (name of theme file with a number attached) of sending theme
#  output = the text sent.
def themeNotify(widget, caller, message):
    pass

#This gets called when an item is dropped on this widget.
# NOTE you have to call acceptDrops() before your widget will accept drops.
#  widget = reference to your theme
#  dropText = the text of the dropped item (probably a URL to it's location in KDE)
#  x = the x position on the theme relative to the upper left corner
#  y = the y position on the theme relative to the upper left corner
def itemDropped(widget, dropText, x, y):
    pass


#This gets called when a new program is LOADING in KDE.  When it is done
#loading, startupRemoved() is called, followed by taskAdded().
#  widget = reference to your widget
#  task = A refence to the task that is starting.  
def startupAdded(widget, startup):
    pass

#This gets called when a new program is done LOADING in KDE.
#  widget = reference to your widget
#  task = A refence to the task that just finished loading.  
def startupRemoved(widget, startup):
    pass

#This is called every time a new task (program) is started in KDE.
#  widget = reference to your widget
#  task = A refence to the new task.  Call getTaskInfo() with this reference
#         to get the name, etc of this new task.
def taskAdded(widget, task):
    pass

#This is called everytime a task (program) is closed in KDE.
#  widget = reference to your widget
#  task = A refence to the task.  
def taskRemoved(widget, task):
    pass

#This is called everytime a different task gains focus (IE, the user clicks
#on a different window).  
#  widget = reference to your widget
#  task = A refence to the task.  Call getTaskInfo() with this reference
#         to get the name, etc of this new task.
def activeTaskChanged(widget, task):
    pass

#This is called everytime the systray you created with createSystray() is updated
def systrayUpdated(widget):
    pass

#This is called everytime the current desktop changes
#  widget = reference to your widget
#  desktop = the current desktop
def desktopChanged(widget, desktop):
    pass

#This is called everytime the wallpaper changes on a desktop 
#  widget = reference to your widget
#  desktop = the desktop whose wallpaper changed
def wallpaperChanged(widget, desktop):
    pass

#This is called everytime there is a key press in any focused input field
#  widget = reference to your widget
#  meter = reference to an input box
#  char = the key that was pressed
def keyPressed(widget, meter, char):
    pass

# This will be printed when the widget loads.
print "Loaded my python extension!"
